package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductInfo;
import com.izouma.awesomeadmin.service.ProductInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/productInfo")
@RequiresAuthentication
public class ProductInfoController {

    @Autowired
    private ProductInfoService productInfoService;

    /**
    * <p>获取全部记录。</p>
    */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductInfo record) {
        List<ProductInfo> pp = productInfoService.getProductInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getProductInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductInfo(@RequestParam(required = false, value = "id") String id) {
        ProductInfo data = productInfoService.getProductInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductInfo record) {
        ProductInfo data = productInfoService.getProductInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductInfo> pp =productInfoService.getProductInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductInfo record) {
        boolean num = productInfoService.createProductInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductInfo(ProductInfo record) {
        boolean num = productInfoService.updateProductInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = productInfoService.deleteProductInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductInfo record) throws Exception {

    List<ProductInfo> productInfos = productInfoService.getProductInfoList(record);


        String sheetName = "product_info";
        String titleName = "商品信息数据表";
        String fileName = "商品信息表";
        int columnNumber = 20;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "大类" ,   "小类" ,   "标题" ,   "主图" ,   "服务详情" ,   "库存" ,   "上下架" ,   "可用" ,   "热门" ,   "首页" ,   "排序" ,   "店铺" ,   "类型" ,   "销量"  };
        String[][] dataList = new String[productInfos.size()][20];

        for (int i = 0; i < productInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(productInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(productInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(productInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(productInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(productInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(productInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(productInfos.get(i).getServiceType());
                        dataList[i][7] = String.valueOf(productInfos.get(i).getSubclass());
                        dataList[i][8] = String.valueOf(productInfos.get(i).getTitle());
                        dataList[i][9] = String.valueOf(productInfos.get(i).getImage());
                        dataList[i][10] = String.valueOf(productInfos.get(i).getServiceDetail());
                        dataList[i][11] = String.valueOf(productInfos.get(i).getInventory());
                        dataList[i][12] = String.valueOf(productInfos.get(i).getOnShelf());
                        dataList[i][13] = String.valueOf(productInfos.get(i).getUseFlag());
                        dataList[i][14] = String.valueOf(productInfos.get(i).getHotFlag());
                        dataList[i][15] = String.valueOf(productInfos.get(i).getHomeFlag());
                        dataList[i][16] = String.valueOf(productInfos.get(i).getRank());
                        dataList[i][17] = String.valueOf(productInfos.get(i).getStoreId());
                        dataList[i][18] = String.valueOf(productInfos.get(i).getTypeFlag());
                        dataList[i][19] = String.valueOf(productInfos.get(i).getSalesVolume());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

